POJ_2251(初识广搜)

Description

You are trapped in a 3D dungeon and need to find the quickest way out! The dungeon is composed of unit cubes which may or may not be filled with rock. It takes one minute to move one unit north, south, east, west, up or down. You cannot move diagonally and the maze is surrounded by solid rock on all sides.

Is an escape possible? If yes, how long will it take?

Input

The input consists of a number of dungeons. Each dungeon
description starts with a line containing three integers L, R and C (all
limited to 30 in size).

L is the number of levels making up the dungeon.

R and C are the number of rows and columns making up the plan of each level.

Then there will follow L blocks of R lines each containing C
characters. Each character describes one cell of the dungeon. A cell
full of rock is indicated by a ‘#‘ and empty cells are represented by a
‘.‘. Your starting position is indicated by ‘S‘ and the exit by the
letter ‘E‘. There‘s a single blank line after each level. Input is
terminated by three zeroes for L, R and C.

Output

Each maze generates one line of output. If it is possible to reach the exit, print a line of the form       
Escaped in x minute(s).
where x is replaced by the shortest time it takes to escape.

If it is not possible to escape, print the line       Trapped!

Sample Input

3 4 5
S....
.###.
.##..
###.#

#####
#####
##.##
##...

#####
#####
#.###
####E

1 3 3
S##
#E#
###

0 0 0

Sample Output

Escaped in 11 minute(s).
Trapped!

这是一个迷宫问题,并且是3D的就是多了个一维度,问从起点S开始所能走到E便成功逃离输出需要多少秒,否则不能逃离。搜索菜鸟,只会深搜的我TLE了,学长教了一遍广搜,有所领悟吧!有一个需要注意的地方是,起点不一定是mp[0][0][0]。需要自己搜一下起点位置,在这个地方wa了好几次。

https://vjudge.net/contest/178007#problem/B
#include<cstdio>
#include<cstring>
#include<queue>
#include<algorithm>
using namespace std;
const int maxn = 35;
char mp[maxn][maxn][maxn];
bool vis[maxn][maxn][maxn];
int dis[6][3]={-1,0,0, 1,0,0, 0,-1,0, 0,0,-1, 0,0,1, 0,1,0};
int n,m,c;

struct Node{
	int x,y,z,step;
};

queue<Node> q;

int bfs(){
	while(!q.empty()){
		Node k,f;
		k=q.front();
		q.pop();
		if(mp[k.x][k.y][k.z]==‘E‘)
			return k.step;
		for(int i=0;i<6;i++){
			int xx=k.x+dis[i][0];
			int yy=k.y+dis[i][1];
			int zz=k.z+dis[i][2];
			if(xx>=0&&yy>=0&&zz>=0&&xx<n&&yy<m&&zz<c&&vis[xx][yy][zz]==0&&mp[xx][yy][zz]!=‘#‘){
				vis[xx][yy][zz]=1;
				f.x=xx; f.y=yy; f.z=zz;
				f.step=k.step+1;
				q.push(f);
			}
		}
	}
	return 0;
}

int main(){

	while(scanf("%d %d %d",&n,&m,&c)==3&&n&&m&&c){
		memset(vis,0,sizeof(vis));
		while(!q.empty()) q.pop();
		for(int i=0;i<n;i++){
			for(int j=0;j<m;j++){
				scanf("%s",mp[i][j]);
				for(int k=0;k<c;k++){
					if(mp[i][j][k]==‘S‘){
						vis[i][j][k]=1;
						Node s;
						s.x=i; s.y=j; s.z=k; s.step=0;
						//vis[s.x][s.y][s.z]=1;
						q.push(s);
					}
				}
			}
		}
		int ans;
		ans = bfs();
		if(ans!=0)
			printf("Escaped in %d minute(s).\n",ans);
		else
			printf("Trapped!\n");
	}
	return 0;
}
时间: 2024-10-12 06:27:09

POJ_2251(初识广搜)的相关文章

NYOJ 284 坦克大战 &amp;&amp; POJ 2312 Battle City (广搜+优先队列)

链接:click here~~ 题意: 描述 Many of us had played the game "Battle city" in our childhood, and some people (like me) even often play it on computer now. What we are discussing is a simple edition of this game. Given a map that consists of empty space

Catch That Cow(广搜)

个人心得:其实有关搜素或者地图啥的都可以用广搜,但要注意标志物不然会变得很复杂,想这题,忘记了标志,结果内存超时: 将每个动作扔入队列,但要注意如何更简便,更节省时间,空间 Farmer John has been informed of the location of a fugitive cow and wants to catch her immediately. He starts at a point N (0 ≤ N ≤ 100,000) on a number line and t

codevs 1225:八数码难题【双向广搜】

这里是传送门 这道题用普通BFS是可以做的,但是很明显没得过,效率太低了.效率更高的算法A*和双向广搜都可取,这写一下双向广搜的. 注意题目中的判重很重要,可以转化成九位数用hash来解决这个问题. #include <set> #include <string> #include <cstdio> #include <cstring> #include <iostream> #include <algorithm> #define

迷宫广搜

上学期学了C,这学期学C++.感觉最难的还是算法,上周作业的一道广搜题是我第一次接触广搜,由于第一学期刚学编程就接触的太多的算法难题,不禁对代码产生畏惧,不过还好没有放弃,虽然算法很难,但我慢慢找到了一点学数学时的乐趣.先介绍一下这道未来的我看过来会觉得很简单一道题吧 You are provided a maze(迷宫), and you need to program to find the least steps to walk from the start to the end.And

宽搜和广搜、

广搜与深搜的小区别 一般来说,广搜常用于找单一的最短路线,或者是规模小的路径搜索,它的特点是"搜到就是最优解", 而深搜用于找多个解或者是"步数已知(好比3步就必需达到前提)"的标题,它的空间效率高,然则找到的不必定是最优解,必需记实并完成全数搜索,故一般情况下,深搜需要很是高效的剪枝(优化). 像搜索最短路径这些的很显著若是用广搜,因为广搜的特征就是一层一层往下搜的,保证当前搜到的都是最优解,当然,最短路径只是一方面的操作,像什么起码状态转换也是可以操作的.深搜就

hdu1241详解 Java广搜搞定

import java.util.Scanner; public class Main{ public static void main(String[] args) { Scanner sc = new Scanner(System.in); while (sc.hasNext()) { int m = sc.nextInt();//输入地图的行数 int n = sc.nextInt();//输入地图的列数 if (m == 0) {//若m=0则退出程序 break; } // 初始化图

poj 1166 The Clocks 记录路径的广搜

题意: 给9个时钟的初始状态,和一些对某几个钟的操作,求最少经过几步能到目标状态(全指向12点). 分析: 明显的广搜,但实现起来的细节要注意:1.因为要记录路径,所以要在整个程序执行过程中扩展出的节点在输出路径前不能销毁, 故采用静态内存分配的方法(开node[600000],用get_node()创建节点.2.queue<node>比queue<int>要多花1别的时间. //poj 1166 //sep9 #include <iostream> #include

nyoj 523 双向广搜

题目链接: http://acm.nyist.net/JudgeOnline/problem.php?pid=523 #include<iostream> #include<cstdio> #include<queue> using namespace std; /* 用普通搜索TLE,已知起点和终点,可以考虑双向广搜或A*算法加速搜索 双向广搜,一个方向从出发点向终点搜索,一个方向从终点向出发点搜索,搜索到相同的结点时,即找到最短路径. */ const int N

hdu 2717 Catch That Cow(广搜bfs)

题目链接:http://i.cnblogs.com/EditPosts.aspx?opt=1 Catch That Cow Time Limit: 5000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 7909    Accepted Submission(s): 2498 Problem Description Farmer John has been inform